package pl.edu.pwr.tkubik.javata;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineFactory;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;
import java.util.List;

/**
 * Aby uruchomić program z linii komend, właczając kompilator GraalVM JIT, należy w katalogu target odpalić polecenie:
 * java -XX:+UnlockExperimentalVMOptions -XX:+EnableJVMCI -p .\scriptingExample-1.0-SNAPSHOT.jar;compiler;"C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\js\\js\\22.2.0\\js-22.2.0.jar;C:\\Users\\tkubik\\.m2\\repository\\com\\ibm\\icu\\icu4j\\71.1\\icu4j-71.1.jar;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\regex\\regex\\22.2.0\\regex-22.2.0.jar;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\js\\js-scriptengine\\22.2.0\\js-scriptengine-22.2.0.jar;" --upgrade-module-path .\compiler\compiler.jar;.\compiler\compiler-management.jar -m scriptingExample/pl.edu.pwr.tkubik.javata.Main
 *
 * Uruchomienie bez włączenia kompilatora:
 * java -p "E:\\Dydaktyka\\JavaWyk2017\\Programy-IntelliJ\\scriptingExample\\target\\classes;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\sdk\\graal-sdk\\22.2.0\\graal-sdk-22.2.0.jar;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\js\\js\\22.2.0\\js-22.2.0.jar;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\regex\\regex\\22.2.0\\regex-22.2.0.jar;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\truffle\\truffle-api\\22.2.0\\truffle-api-22.2.0.jar;C:\\Users\\tkubik\\.m2\\repository\\com\\ibm\\icu\\icu4j\\71.1\\icu4j-71.1.jar;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\js\\js-scriptengine\\22.2.0\\js-scriptengine-22.2.0.jar;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\tools\\profiler\\22.2.0\\profiler-22.2.0.jar;C:\\Users\\tkubik\\.m2\\repository\\org\\graalvm\\tools\\chromeinspector\\22.2.0\\chromeinspector-22.2.0.jar" -m scriptingExample/pl.edu.pwr.tkubik.javata.Main
 *
 * Z wykorzystaniem pluginów:
 *  mvn test (by skopiować zależności do folderu terget/compiler
 *  mvn exec:exec (by uruchomić aplikację, zobacz też parametry przekazane do JVM)
 */
public class Main {
    public static void main(String[] args) {
        ScriptEngineManager mgr = new ScriptEngineManager();

        List<ScriptEngineFactory> engines = (new ScriptEngineManager()).getEngineFactories();
        for (ScriptEngineFactory f: engines) {
            System.out.println(f.getLanguageName()+" "+f.getEngineName()+" "+f.getNames().toString());
        }

        ScriptEngine jsEngine = mgr.getEngineByName("graal.js");
        try {
            jsEngine.eval("print('Hello, world!')");
        } catch (ScriptException ex) {
            ex.printStackTrace();
        }
    }
}